package com.sun.corba.se.impl.ior;

import com.sun.corba.se.spi.orb.ORBVersionFactory;
import org.omg.CORBA.INTERNAL;
import com.sun.corba.se.spi.orb.ORBVersion;
import org.omg.CORBA_2_3.portable.OutputStream;
import org.omg.CORBA.OctetSeqHolder;
import org.omg.CORBA_2_3.portable.InputStream;
import com.sun.corba.se.spi.orb.ORB;

public final class OldPOAObjectKeyTemplate extends OldObjectKeyTemplateBase
{
    public OldPOAObjectKeyTemplate(ORB orb, int n, int n2, InputStream inputStream) {
        this(orb, n, n2, inputStream.read_long(), inputStream.read_long(), inputStream.read_long());
    }
    
    public OldPOAObjectKeyTemplate(ORB orb, int n, int n2, InputStream inputStream, OctetSeqHolder octetSeqHolder) {
        this(orb, n, n2, inputStream);
        octetSeqHolder.value = this.readObjectKey(inputStream);
    }
    
    public OldPOAObjectKeyTemplate(ORB orb, int n, int n2, int n3, int i, int n4) {
        super(orb, n, n2, n3, Integer.toString(i), new ObjectAdapterIdNumber(n4));
    }
    
    public void writeTemplate(OutputStream outputStream) {
        outputStream.write_long(this.getMagic());
        outputStream.write_long(this.getSubcontractId());
        outputStream.write_long(this.getServerId());
        outputStream.write_long(Integer.parseInt(this.getORBId()));
        outputStream.write_long(((ObjectAdapterIdNumber)(ObjectAdapterIdNumber)this.getObjectAdapterId()).getOldPOAId());
    }
    
    @Override
    public ORBVersion getORBVersion() {
        if (this.getMagic() == -1347695874) {
            return ORBVersionFactory.getOLD();
        }
        if (this.getMagic() == -1347695873) {
            return ORBVersionFactory.getNEW();
        }
        throw new INTERNAL();
    }
}
